#include "..\..\..\drivers\tcpipcore.h"
#include "dhcp_app.h"

// DHCP debug message enable
//#define DHCP_DEBUG

RIP_MSG xdata MSG;
					
extern uint8 xdata Debug_Off;
extern uint8 xdata Enable_DHCP_Timer;
extern uint8 xdata Mac[6]; 
extern uint8 xdata SubMask[4];
extern uint8 xdata Gateway[4];
extern uint8 xdata IpAddr[4];
uint8 xdata txsize[MAX_SOCK_NUM] = {8,2,1,1,1,1,1,1};
uint8 xdata rxsize[MAX_SOCK_NUM] = {8,2,1,1,1,1,1,1};

uint8 xdata DNS[4];
uint8 xdata OLD_SIP[4];
uint8 xdata DHCPS_IP[4];
uint8 xdata tmp_DHCPS_IP[4];
uint8 xdata ServerIP[4], MyIP[4];
uint16 xdata S_port;				// DHCP Server Port Number
uint8 xdata Device_Name[14];

un_l2cval xdata lease_time;
volatile uint32 xdata my_time;
uint32 xdata next_time;

uint8 xdata retry_count = 0;
uint8 xdata DHCP_Timeout = 0;

uint32 xdata DHCP_XID;
uint8 xdata SameIPCnt;
uint8 xdata dhcp_state;

void send_DHCP_DISCOVER(SOCKET s)
{
	uint16 xdata i;
	uint8 xdata addr[4];
	uint16 xdata k = 0;

	MSG.op = DHCP_BOOTREQUEST;
	MSG.htype = DHCP_HTYPE10MB;
	MSG.hlen = DHCP_HLENETHERNET;
	MSG.hops = DHCP_HOPS; // Client set to zero
	MSG.xid = DHCP_XID; //Transaction ID
	MSG.secs = DHCP_SECS; //Filled in by client, address acquisition or renewal process
	MSG.flags = DHCP_FLAGSBROADCAST; 
	// client's IP addres
	memset(MSG.ciaddr, 0x00, sizeof(MSG.ciaddr));
	// your (i.e., client) IP address (filled in by server)
	memset(MSG.yiaddr, 0x00, sizeof(MSG.yiaddr));
	// server's IP address
	memset(MSG.siaddr, 0x00, sizeof(MSG.siaddr));
	// agent IP address
	memset(MSG.giaddr, 0x00,sizeof(MSG.giaddr));
	
	// Client hardware address 
	memset(MSG.chaddr, 0x00,sizeof(MSG.chaddr));
	for (i = 0; i < 6; i++) MSG.chaddr[i] = Mac[i];
	// Optinal server host name
	memset(MSG.sname, 0x00, sizeof(MSG.sname));
	// Boot file name	
	memset(MSG.file, 0x00, sizeof(MSG.file));
	
	// MAGIC_COOKIE
	MSG.OPT[k++] = MAGIC0; MSG.OPT[k++] = MAGIC1;
	MSG.OPT[k++] = MAGIC2; MSG.OPT[k++] = MAGIC3;
	MSG.OPT[k++] = dhcpMessageType;
	MSG.OPT[k++] = 0x01;
	MSG.OPT[k++] = DHCP_DISCOVER;
	MSG.OPT[k++] = dhcpClientIdentifier;
	MSG.OPT[k++] = 0x07;
	MSG.OPT[k++] = 0x01;
	MSG.OPT[k++] = Mac[0];
	MSG.OPT[k++] = Mac[1];
	MSG.OPT[k++] = Mac[2];
	MSG.OPT[k++] = Mac[3];
	MSG.OPT[k++] = Mac[4];
	MSG.OPT[k++] = Mac[5];
	MSG.OPT[k++] = hostName;
	MSG.OPT[k++] = 14;
	for (i = 0; i < 14; i++) 	MSG.OPT[k++] = Device_Name[i];
	MSG.OPT[k++] = dhcpParamRequest;
	MSG.OPT[k++] = 0x05;
	MSG.OPT[k++] = subnetMask;
	MSG.OPT[k++] = routersOnSubnet;
	MSG.OPT[k++] = dns;
	MSG.OPT[k++] = dhcpT1value;
	MSG.OPT[k++] = dhcpT2value;
	MSG.OPT[k++] = endOption;
	// Null Padding
	for (i = k; i < OPT_SIZE; i++) MSG.OPT[i] = 0;

	// DST IP : BroadCasting
	S_port = DHCP_SERVER_PORT;
	for (i=0; i<4; i++) addr[i] = 0xFF;	

#ifdef DHCP_DEBUG
	printf("send_DHCP_DISCOVER : \r\n");
#endif

	// send MSG to Broadcasting
	sendto(s, (uint8 *)(&MSG.op), RIP_MSG_SIZE, addr, S_port);

}

void send_DHCP_REQUEST(SOCKET s, uint8 REREQ)
{
	uint16 xdata i;
	uint8 xdata addr[4];
	uint16 xdata k = 0;

	MSG.op = DHCP_BOOTREQUEST;
	MSG.htype = DHCP_HTYPE10MB;
	MSG.hlen = DHCP_HLENETHERNET;
	MSG.hops = DHCP_HOPS;
	MSG.xid = DHCP_XID;
	MSG.secs = DHCP_SECS;
	MSG.flags = DHCP_FLAGSBROADCAST;

	memset(MSG.ciaddr,0x00,sizeof(MSG.ciaddr));
	memset( MSG.yiaddr,0x00,sizeof(MSG.yiaddr));
	memset( MSG.siaddr,0x00,sizeof(MSG.siaddr));
	memset( MSG.giaddr,0x00,sizeof(MSG.giaddr));
	memset( MSG.chaddr,0x00,sizeof(MSG.chaddr));
	for (i = 0; i < 6; i++) MSG.chaddr[i] = Mac[i];
	memset( MSG.sname,0x00,sizeof(MSG.sname));
	memset( MSG.file,0x00,sizeof(MSG.file));

	// MAGIC_COOKIE
	MSG.OPT[k++] = MAGIC0;
	MSG.OPT[k++] = MAGIC1;
	MSG.OPT[k++] = MAGIC2;
	MSG.OPT[k++] = MAGIC3;

	// Option Request Param.
	MSG.OPT[k++] = dhcpMessageType;
	MSG.OPT[k++] = 0x01;
	MSG.OPT[k++] = DHCP_REQUEST;
	MSG.OPT[k++] = dhcpClientIdentifier;
	MSG.OPT[k++] = 0x07;
	MSG.OPT[k++] = 0x01;
	MSG.OPT[k++] = Mac[0];
	MSG.OPT[k++] = Mac[1];
	MSG.OPT[k++] = Mac[2];
	MSG.OPT[k++] = Mac[3];
	MSG.OPT[k++] = Mac[4];
	MSG.OPT[k++] = Mac[5];
	MSG.OPT[k++] = dhcpRequestedIPaddr;
	MSG.OPT[k++] = 0x04;
	if(REREQ != 0) {
		MSG.OPT[k++] = MyIP[0];
		MSG.OPT[k++] = MyIP[1];
		MSG.OPT[k++] = MyIP[2];
		MSG.OPT[k++] = MyIP[3];
	}
	else {
		MSG.OPT[k++] = IpAddr[0];
		MSG.OPT[k++] = IpAddr[1];
		MSG.OPT[k++] = IpAddr[2];
		MSG.OPT[k++] = IpAddr[3];
	}
	MSG.OPT[k++] = dhcpServerIdentifier;
	MSG.OPT[k++] = 0x04;
	if(REREQ != 0) {
		MSG.OPT[k++] = ServerIP[0];
		MSG.OPT[k++] = ServerIP[1];
		MSG.OPT[k++] = ServerIP[2];
		MSG.OPT[k++] = ServerIP[3];
	}
	else {
		MSG.OPT[k++] = DHCPS_IP[0];
		MSG.OPT[k++] = DHCPS_IP[1];
		MSG.OPT[k++] = DHCPS_IP[2];
		MSG.OPT[k++] = DHCPS_IP[3];
	}
	MSG.OPT[k++] = hostName;
	MSG.OPT[k++] = 14;
	for (i = 0; i < 14; i++) 	MSG.OPT[k++] = Device_Name[i];
	
	MSG.OPT[k++] = dhcpParamRequest;
	MSG.OPT[k++] = 0x05;
	MSG.OPT[k++] = subnetMask;
	MSG.OPT[k++] = routersOnSubnet;

	MSG.OPT[k++] = dns;
	MSG.OPT[k++] = dhcpT1value;
	MSG.OPT[k++] = dhcpT2value;
	MSG.OPT[k++] = endOption;

	// ZERO padding	
	for (i = k; i < OPT_SIZE; i++) MSG.OPT[i] = 0;

	/* DST IP : BroadCasting*/
	S_port = DHCP_SERVER_PORT;
	if(REREQ != 0) 
		for (i=0; i<4; i++) addr[i] = ServerIP[i]; 
	else
		for (i=0; i<4; i++) addr[i] = 0xFF;	
	
#ifdef DHCP_DEBUG
	printf("send_DHCP_REQUEST \r\n");
#endif	

		// send MSG to Broadcasting
	sendto(s, (uint8 *)(&MSG.op), RIP_MSG_SIZE, addr, S_port);
}



char parseDHCPMSG(SOCKET s, uint16 length)
{
	uint8 xdata ServerAddrIn[4];
	uint16 xdata  ServerPort;
	uint16 xdata len;
	uint8 xdata type,i,opt_len;
	uint8 xdata * p;
	uint8 xdata * e;			 

	len = 0;
	len = recvfrom(s, (uint8*)&MSG.op, length, ServerAddrIn, &ServerPort);

#ifdef _DHCP_DEBUG_										  
	printf("ServerPort: %d \r\n", (int)ServerPort);	
	printf("Message Type %.2bx \r\n ", MSG.op );
#endif

	if (ServerPort == DHCP_SERVER_PORT)
	{
#ifdef _DHCP_DEBUG										  
		printf("\n\r DHCP MSG received : len = %d", (int)len);
		printf("\n\r SRC MAC %.2bx.%.2bx.%.2bx.%.2bx.%.2bx.%.2bx\r\n", 
          Mac[0], Mac[1],Mac[2],Mac[3],Mac[4],Mac[5]);
#endif	
		for (i = 0; i < 6; i++) {
			if (MSG.chaddr[i] != Mac[i]) 
			return(0);
		}
		
		//DHCP Server IP
		for(i = 0; i < 4; i++) {
			DHCPS_IP[i] = MSG.siaddr[i];
		}
		
		for (i = 0; i < 4; i++){
			IpAddr[i] = MSG.yiaddr[i];		
		}
		
	}

	type = 0;
	p = (uint8*)(&MSG.op);
	p = p + POS_OPTION;
	e = p + (len - POS_OPTION);

	while ( p < e )
	{
 		switch ( *p++ )
		{
			case endOption :
				return type;
				break;

       		case padOption :
				break;

     		case dhcpMessageType :
				opt_len = *p++;
				type = *p;
#ifdef _DHCP_DEBUG_
				printf("dhcpMessageType%.2bu \r\n", dhcpMessageType);
#endif
				break;

       		case subnetMask :
			    opt_len = *p++;
				//for (i = 0; i < 4; i++)	SubMask[i] = *p++;
				memcpy(SubMask,p,4);
				
#ifdef _DHCP_DEBUG_
				printf("subnnetMask %.2bu.%.2bu.%.2bu.%.2bu\r\n", 
				SubMask[0], SubMask[1],SubMask[2],SubMask[3]);
#endif
				break;

       		case routersOnSubnet :
				opt_len = *p++;
				memcpy(Gateway,p,4);
				
#ifdef _DHCP_DEBUG_
				printf("routersOnSubnet %.2bu.%.2bu.%.2bu.%.2bu\r\n", 
				Gateway[0], Gateway[1], Gateway[2], Gateway[3]);
#endif	
				break;

	       	case dns :
				opt_len = *p++;
				memcpy(DNS,p,4);				
				
#ifdef _DHCP_DEBUG
				printf("dns %.2bu.%.2bu.%.2bu.%.2bu\r\n", 
				DNS[0], DNS[1], DNS[2], DNS[3]);
#endif
				break;

			case dhcpIPaddrLeaseTime :  // unit sec.
				opt_len = *p++;
				lease_time.lVal = ntohl(*((uint32*)p));
			
#ifdef _DHCP_DEBUG
				printf("dhcpIPaddrLeaseTime : %.2bu.%.2bu.%.2bu.%.2bu\r\n", 
				lease_time.cVal[0], lease_time.cVal[1],lease_time.cVal[2],lease_time.cVal[3]);
				printf("lease time = %bu\r\n",lease_time.lVal);
#endif		
				break;							

			case dhcpServerIdentifier :
				opt_len = *p++;
				memcpy(DHCPS_IP,p,4);
#ifdef _DHCP_DEBUG
				printf("dhcpServerIdentifier %.2bu.%.2bu.%.2bu.%.2bu\r\n", 
				DHCPS_IP[0], DHCPS_IP[1], DHCPS_IP[2], DHCPS_IP[3]);
#endif		
				break;
				
			default :
				opt_len = *p++;			
#ifdef _DHCP_DEBUG_
				printf("opt_len %.2bu \r\n", opt_len);
#endif

				break;
		}
		p += opt_len;
	}
    return	type;
}


void check_retry(void)
{
	if (retry_count < MAX_DHCP_RETRY) {
		if (next_time < my_time) {
			my_time = 0;
			next_time = my_time + DHCP_WAIT_TIME;
			retry_count++;
			switch ( dhcp_state ) {
				case STATE_DHCP_DISCOVER :
					send_DHCP_DISCOVER(SOCK_DHCP);
				break;
		
				case STATE_DHCP_REQUEST :
					send_DHCP_REQUEST(SOCK_DHCP, 0);
				break;

				case STATE_DHCP_REREQUEST :
					for(;socket(SOCK_DHCP, Sn_MR_UDP, DHCP_CLIENT_PORT, 0x0)!=1;);
					DHCP_XID ++;
					send_DHCP_REQUEST(SOCK_DHCP, 1);
				break;
		
				default :
				break;
			}
		}
	} else {
		printf("Time out.\r\n");
		DHCP_Timeout = 1;
		
		my_time = 0;
		next_time = my_time + DHCP_WAIT_TIME;
		retry_count = 0;
		send_DHCP_DISCOVER(SOCK_DHCP);
		dhcp_state = STATE_DHCP_DISCOVER;
		
	}
}

void set_network(void)
{
	uint8 xdata str[17]; 
	//uint8 xdata rsn[4];
	//SetSubnet(SubMask);

#ifdef DHCP_DEBUG
	printf(" << Set Network(DHCP) >>\r\n");
#endif	

	IINCHIP_WRITE(MR,MR_RST);
	
	IINCHIP_WRITE((GAR0 + 0),Gateway[0]); IINCHIP_WRITE((GAR0 + 1),Gateway[1]); 
	IINCHIP_WRITE((GAR0 + 2),Gateway[2]); IINCHIP_WRITE((GAR0 + 3),Gateway[3]);

	IINCHIP_WRITE((SUBR0 + 0),SubMask[0]); IINCHIP_WRITE((SUBR0 + 1),SubMask[1]);
	IINCHIP_WRITE((SUBR0 + 2),SubMask[2]); IINCHIP_WRITE((SUBR0 + 3),SubMask[3]);

	IINCHIP_WRITE((SIPR0 + 0),IpAddr[0]); IINCHIP_WRITE((SIPR0 + 1),IpAddr[1]);
	IINCHIP_WRITE((SIPR0 + 2),IpAddr[2]); IINCHIP_WRITE((SIPR0 + 3),IpAddr[3]);

	IINCHIP_WRITE((SHAR0 + 0),Mac[0]); IINCHIP_WRITE((SHAR0 + 1),Mac[1]);
	IINCHIP_WRITE((SHAR0 + 2),Mac[2]); IINCHIP_WRITE((SHAR0 + 3),Mac[3]);
	IINCHIP_WRITE((SHAR0 + 4),Mac[4]); IINCHIP_WRITE((SHAR0 + 5),Mac[5]);
 	
	IINCHIP_WRITE(RCR,3);
	
	set_MEMsize(txsize,rxsize);
	
	printf("DHCP_ Server %bu.%bu.%bu.%bu\r\n", 
	DHCPS_IP[0], DHCPS_IP[1], DHCPS_IP[2], DHCPS_IP[3]);

 	sprintf(str,"%bu.%bu.%bu.%bu",
			IINCHIP_READ (SIPR0+0), IINCHIP_READ (SIPR0+1), 
			IINCHIP_READ (SIPR0+2), IINCHIP_READ (SIPR0+3));
	printf( "LOCAL IP ADDRESS : %s\r\n", str);

 	sprintf(str,"%bu.%bu.%bu.%bu",
			IINCHIP_READ (SUBR0+0), IINCHIP_READ (SUBR0+1), 
			IINCHIP_READ (SUBR0+2), IINCHIP_READ (SUBR0+3));
	printf( "SUBNET MASK  : %s\r\n",str); 

 	sprintf(str,"%bu.%bu.%bu.%bu",
			IINCHIP_READ (GAR0+0), IINCHIP_READ (GAR0+1), 
			IINCHIP_READ (GAR0+2), IINCHIP_READ (GAR0+3));
	printf( "G/W IP ADDRESS : %s\r\n",str);


}

void check_dhcp(void) 
{
	uint16 xdata len;
	uint8 xdata i, flag, type ;

	len = 0;
	len = getSn_RX_RSR(SOCK_DHCP);

	if (len > 0) {
	
	 type = parseDHCPMSG(SOCK_DHCP, len);
#ifdef _DHCP_DEBUG
printf("Type = %d (%d) \r\n",(int)type, (int)DHCP_OFFER);
printf("dhcp_state : %d\r\n",(int)dhcp_state );
#endif

	}
	
	switch ( dhcp_state ) {
		case STATE_DHCP_DISCOVER : 
			if (type == DHCP_OFFER) {

#ifdef DHCP_DEBUG
	printf("Receive DHCP_Offer\r\n");
#endif
				send_DHCP_REQUEST(SOCK_DHCP, 0);
				dhcp_state = STATE_DHCP_REQUEST;
#ifdef DHCP_DEBUG
				printf("state_dhcp_request %d\r\n",(int)dhcp_state);
#endif
				tmp_DHCPS_IP[3] = DHCPS_IP[3];
				tmp_DHCPS_IP[2] = DHCPS_IP[2];
				tmp_DHCPS_IP[1] = DHCPS_IP[1];
				tmp_DHCPS_IP[0] = DHCPS_IP[0];

#ifdef DHCP_DEBUG
	printf("state : STATE_DHCP_REQUEST\r\n");
#endif
				
			} else check_retry(); // resend DISCOVER message
		break;

		case STATE_DHCP_REQUEST :
			if (type == DHCP_ACK) {
#ifdef DHCP_DEBUG
	printf(" Receive ACK\r\n");
#endif
				
					set_network();

					for (i=0; i<4; i++) ServerIP[i] = DHCPS_IP[i];
					for (i=0; i<4; i++) MyIP[i] = IpAddr[i];

					dhcp_state = STATE_DHCP_LEASED;
					my_time = 0;
					next_time = my_time + DHCP_WAIT_TIME;
					retry_count = 0;
#ifdef DHCP_DEBUG
	printf("state : STATE_DHCP_LEASED\r\n");
#endif
				
				
			} else if (type == DHCP_NAK) {
			 //avoid to NAK caused from DHCP Server which didn't offer to Client
			if( !(tmp_DHCPS_IP[3] == DHCPS_IP[3] &&
				tmp_DHCPS_IP[2] == DHCPS_IP[2] &&
				tmp_DHCPS_IP[1] == DHCPS_IP[1]&&
				tmp_DHCPS_IP[0] == DHCPS_IP[0]) )
			 break;
		

#ifdef DHCP_DEBUG
	printf(" Receive NACK");
#endif
				my_time = 0;
				next_time = my_time + DHCP_WAIT_TIME;
				retry_count = 0;
				dhcp_state = STATE_DHCP_DISCOVER;
			} else check_retry();	// resend REQUEST message
		break;

		case STATE_DHCP_LEASED :
			if ((lease_time.lVal != 0xffffffff) && ((lease_time.lVal/2) < my_time)) {
#ifdef DHCP_DEBUG
	printf(">>>> STATE_DHCP_LEASED\r\n");
#endif
				
				type = 0;
				for (i = 0; i < 4; i++)	OLD_SIP[i] = IpAddr[i];
				
				for(;socket(SOCK_DHCP, Sn_MR_UDP, DHCP_CLIENT_PORT, 0x0)!=1;);
				DHCP_XID++;
				send_DHCP_REQUEST(SOCK_DHCP, 1);
				
				dhcp_state = STATE_DHCP_REREQUEST;
				my_time = 0;
				next_time = my_time + DHCP_WAIT_TIME;
			}
			break;

		case STATE_DHCP_REREQUEST :

#ifdef DHCP_DEBUG
	printf(" < STATE_DHCP_REREQUEST >\r\n");
	printf("type : %.2bu\r\n",type);
#endif
			if (type == DHCP_ACK) {
				retry_count = 0;
				flag = 0;
				
				for (i = 0; i < 4; i++)	{
					if (OLD_SIP[i] != IpAddr[i]) {
						flag = 1;
						break;
					}
				}
				
				if (flag) {
					my_time = 0;
					set_network(); // re-setting
				} 
				
				my_time = 0;
				next_time = my_time + DHCP_WAIT_TIME;
				dhcp_state = STATE_DHCP_LEASED;
			} 
			else if (type == DHCP_NAK) {
				my_time = 0;
				next_time = my_time + DHCP_WAIT_TIME;
				retry_count = 0;
				dhcp_state = STATE_DHCP_DISCOVER;
				printf("state : STATE_DHCP_DISCOVER\r\n");
			} 
			else {
#ifdef DHCP_DEBUG
	printf(" Check Retry \r\n");
#endif
				check_retry();
			}
			
		break;

		case STATE_DHCP_RELEASE :
		break;

		default :
		break;
	}
}

void Set_Device_Name(void)
{
	uint8 xdata i;

	// Device Name
	Device_Name[0] = '7';
	Device_Name[1] = '1';
	Device_Name[2] = '0';
	Device_Name[3] = '0';
	Device_Name[4] = 'D';
	Device_Name[5] = 'H';
	Device_Name[6] = 'C';
	Device_Name[7] = 'P';

	for (i = 0; i < 3; i++)
	{
		if ((Mac[3+i] / 0x10) >= 10)
			Device_Name[8+i*2] = 'A'+((Mac[3+i]/0x10)%0x0A);
		else
			Device_Name[8+i*2] = '0'+((Mac[3+i]/0x10)%0x0A);

		if ((Mac[3+i] % 0x10) >= 10)
			Device_Name[9+i*2] = 'A' + ((Mac[3+i]%0x10)%0x0A);
		else
			Device_Name[9+i*2] = '0' + ((Mac[3+i]%0x10)%0x0A);
	}

}

char DHCP_SetIP()
{
	printf("\n\r>DHCP mode\r\n");
	Set_Device_Name();

	DHCP_XID = 0x12345665;

	for(;socket(SOCK_DHCP, Sn_MR_UDP, DHCP_CLIENT_PORT, 0x0)!=1;);
	
	send_DHCP_DISCOVER(SOCK_DHCP);
	dhcp_state = STATE_DHCP_DISCOVER;
	
	SameIPCnt = 0;
	my_time = 0;
	next_time = my_time + DHCP_WAIT_TIME;
	retry_count = 0;
	Enable_DHCP_Timer = 1;
	
	while (dhcp_state != STATE_DHCP_LEASED) {
		check_dhcp();
		if (SameIPCnt >= 2) {
#ifdef DHCP_DEBUG
		printf("Fail:SameIP\r\n");
#endif
			return(0);
		}
		if (DHCP_Timeout == 1) return(0);
	}
	
	return 1;
}



void Init_Timer0(void) 
{
	EA = 0;
	TR0 = 0;
	TF0 = 0;
	TMOD = 0x01;

	TL0 = TIMER0_COUNT & 0x00FF;
	TH0 = TIMER0_COUNT >> 8;

	PT0 = 0;
	ET0 = 1;
	EA = 1;
	TR0 = 1;
}


void Init_Net_Default(void)
{
	uint8 tmp[4] = {0,0,0,0};

	IINCHIP_WRITE(MR,MR_RST);
	//MAC
	IINCHIP_WRITE((SHAR0 + 0),Mac[0]); IINCHIP_WRITE((SHAR0 + 1),Mac[1]); IINCHIP_WRITE((SHAR0 + 2),Mac[2]);
	IINCHIP_WRITE((SHAR0 + 3),Mac[3]); IINCHIP_WRITE((SHAR0 + 4),Mac[4]); IINCHIP_WRITE((SHAR0 + 5),Mac[5]);
	//Gateway
	IINCHIP_WRITE((GAR0 + 0),tmp[0]); IINCHIP_WRITE((GAR0 + 1),tmp[1]);
	IINCHIP_WRITE((GAR0 + 2),tmp[2]); IINCHIP_WRITE((GAR0 + 3),tmp[3]);
	//Subnet Mask
	IINCHIP_WRITE((SUBR0 + 0), tmp[0]); IINCHIP_WRITE((SUBR0 + 1), tmp[1]);
	IINCHIP_WRITE((SUBR0 + 2), tmp[2]); IINCHIP_WRITE((SUBR0 + 3), tmp[3]);
	//Local IP address
	IINCHIP_WRITE((SIPR0 + 0 ), tmp[0]); IINCHIP_WRITE((SIPR0 + 1 ), tmp[1]);	
	IINCHIP_WRITE((SIPR0 + 2 ), tmp[2]); IINCHIP_WRITE((SIPR0 + 3 ), tmp[3]);	
	//Retransmission Time-out Register (delay 600ms)
	IINCHIP_WRITE(RTR,(uint8)((6000 & 0xff00) >> 8)); // 600ms
	IINCHIP_WRITE((RTR + 1),(uint8)(6000 & 0x00ff));
	//Retry Count Register
	IINCHIP_WRITE(RCR,3);

	set_MEMsize(txsize,rxsize);
}


void Init_Net(void)
{
	 uint8 xdata str[17];
  									 
	IINCHIP_WRITE(MR,MR_RST);
	//MAC
	IINCHIP_WRITE((SHAR0 + 0),Mac[0]); IINCHIP_WRITE((SHAR0 + 1),Mac[1]);
	IINCHIP_WRITE((SHAR0 + 2),Mac[2]); IINCHIP_WRITE((SHAR0 + 3),Mac[3]);
    IINCHIP_WRITE((SHAR0 + 4),Mac[4]); IINCHIP_WRITE((SHAR0 + 5),Mac[5]);
	//Gateway
	IINCHIP_WRITE((GAR0 + 0),Gateway[0]); IINCHIP_WRITE((GAR0 + 1),Gateway[1]);
	IINCHIP_WRITE((GAR0 + 2),Gateway[2]); IINCHIP_WRITE((GAR0 + 3),Gateway[3]);
	//Subnet Mask
	IINCHIP_WRITE((SUBR0 + 0), SubMask[0]); IINCHIP_WRITE((SUBR0 + 1), SubMask[1]);
	IINCHIP_WRITE((SUBR0 + 2), SubMask[2]); IINCHIP_WRITE((SUBR0 + 3), SubMask[3]);
	//Local IP address
	IINCHIP_WRITE((SIPR0 + 0 ), IpAddr[0]);	IINCHIP_WRITE((SIPR0 + 1 ), IpAddr[1]);	
	IINCHIP_WRITE((SIPR0 + 2 ), IpAddr[2]);	IINCHIP_WRITE((SIPR0 + 3 ), IpAddr[3]);	
	//Retransmission Time-out Register (delay 600ms)
	IINCHIP_WRITE(RTR,(uint8)((20000 & 0xff00) >> 8));	// RTR : 2s
	IINCHIP_WRITE((RTR + 1),(uint8)(20000 & 0x00ff));
	//Retry Count Register
	IINCHIP_WRITE(RCR,3);

	set_MEMsize(txsize,rxsize);

	// Print DHCP information to UART
	printf("====================================\r\n");
	printf("   W7100 DHCP  \r\n");
	printf("====================================\r\n");

	printf( "MAC ADDRESS : %.2bx.%.2bx.%.2bx.%.2bx.%.2bx.%.2bx\r\n", 
		IINCHIP_READ (SHAR0+0), IINCHIP_READ (SHAR0+1), 
		IINCHIP_READ (SHAR0+2), IINCHIP_READ (SHAR0+3),
		IINCHIP_READ (SHAR0+4), IINCHIP_READ (SHAR0+5)
		) ;

 	sprintf(str,"%.3bu.%.3bu.%.3bu.%.3bu",
			IINCHIP_READ (SUBR0+0), IINCHIP_READ (SUBR0+1), 
			IINCHIP_READ (SUBR0+2), IINCHIP_READ (SUBR0+3));
	printf( "SUBNET MASK  : %s\r\n",str); 

 	sprintf(str,"%.3bu.%.3bu.%.3bu.%.3bu",
			IINCHIP_READ (GAR0+0), IINCHIP_READ (GAR0+1), 
			IINCHIP_READ (GAR0+2), IINCHIP_READ (GAR0+3));
	printf( "G/W IP ADDRESS : %s\r\n",str);

 	sprintf(str,"%.3bu.%.3bu.%.3bu.%.3bu",
			IINCHIP_READ (SIPR0+0), IINCHIP_READ (SIPR0+1), 
			IINCHIP_READ (SIPR0+2), IINCHIP_READ (SIPR0+3));
  printf( "LOCAL IP ADDRESS : %s\r\n", str);
  printf("====================================\r\n");

}
